// Code generated by go-bindata.
// sources:
// generator/server/templates/connection.gotmpl
// generator/server/templates/object.gotmpl
// DO NOT EDIT!

package server

import (
	"bytes"
	"compress/gzip"
	"fmt"
	"io"
	"io/ioutil"
	"os"
	"path/filepath"
	"strings"
	"time"
)

func bindataRead(data []byte, name string) ([]byte, error) {
	gz, err := gzip.NewReader(bytes.NewBuffer(data))
	if err != nil {
		return nil, fmt.Errorf("Read %q: %v", name, err)
	}

	var buf bytes.Buffer
	_, err = io.Copy(&buf, gz)
	clErr := gz.Close()

	if err != nil {
		return nil, fmt.Errorf("Read %q: %v", name, err)
	}
	if clErr != nil {
		return nil, err
	}

	return buf.Bytes(), nil
}

type asset struct {
	bytes []byte
	info  os.FileInfo
}

type bindataFileInfo struct {
	name    string
	size    int64
	mode    os.FileMode
	modTime time.Time
}

func (fi bindataFileInfo) Name() string {
	return fi.name
}
func (fi bindataFileInfo) Size() int64 {
	return fi.size
}
func (fi bindataFileInfo) Mode() os.FileMode {
	return fi.mode
}
func (fi bindataFileInfo) ModTime() time.Time {
	return fi.modTime
}
func (fi bindataFileInfo) IsDir() bool {
	return false
}
func (fi bindataFileInfo) Sys() interface{} {
	return nil
}

var _templatesConnectionGotmpl = []byte("\x1f\x8b\x08\x00\x00\x09\x6e\x88\x00\xff\x6c\x8f\x31\x6e\xeb\x30\x10\x44\x7b\x9e\x62\xbe\x2a\xe9\x23\x96\x9b\x54\x01\x54\xa5\x4f\x97\xca\x70\x41\xd1\x2b\x61\x21\x71\x29\x2c\xa9\xa4\x20\x78\xf7\x20\xb4\xe1\x18\x41\x1a\x16\xc4\x9b\x99\xb7\x39\xe3\x42\x13\x0b\xa1\x71\x41\x84\x5c\xe2\x20\x0d\x4a\xd9\xac\x5b\xec\x4c\x98\xec\xa8\xec\x8c\x61\xbf\x05\x4d\x68\x0d\x00\xb8\xe8\xd1\xcc\x9c\x56\x3b\xf6\x2e\xf8\x63\x7a\x8e\x9b\xd5\x24\xa4\xf1\xe8\xa2\x3f\xcc\xe1\xb0\xf2\xd8\x98\xce\x98\x0f\xab\x70\x41\x22\x06\x78\xbb\x50\xeb\xed\x76\x8a\x49\x59\xe6\xf3\x7f\x17\x7d\xff\x7a\x5f\xed\x2a\xbb\x2b\x63\x40\x93\x33\xfa\x77\x5d\x51\x4a\x63\xcc\xb4\x8b\xc3\x0f\xd8\x6e\xca\xe2\x78\x5b\x09\x2c\x89\x74\xb2\x8e\x72\xe9\xf0\xab\x0f\xf9\xea\x1a\xe4\x09\x61\xc1\xcb\x50\x3d\x4e\xf7\x70\xdf\x5e\x3d\xba\x73\xe5\x78\xc2\xbf\xb0\xdc\x42\xb7\x20\x86\xef\x53\xfb\x37\xfa\x7c\x58\xdf\x95\xbb\x47\xe8\xcf\x4a\xd4\xb5\x8a\x95\xfa\x2a\xa5\x5d\xa5\x7e\x16\x93\x33\x48\x2e\x28\xe5\x2b\x00\x00\xff\xff\xb2\x3f\x93\x1f\x7f\x01\x00\x00")

func templatesConnectionGotmplBytes() ([]byte, error) {
	return bindataRead(
		_templatesConnectionGotmpl,
		"templates/connection.gotmpl",
	)
}

func templatesConnectionGotmpl() (*asset, error) {
	bytes, err := templatesConnectionGotmplBytes()
	if err != nil {
		return nil, err
	}

	info := bindataFileInfo{name: "templates/connection.gotmpl", size: 383, mode: os.FileMode(420), modTime: time.Unix(1490636757, 0)}
	a := &asset{bytes: bytes, info: info}
	return a, nil
}

var _templatesObjectGotmpl = []byte("\x1f\x8b\x08\x00\x00\x09\x6e\x88\x00\xff\xc4\x57\x5d\x4f\xec\x36\x10\x7d\xcf\xaf\x98\xe6\x81\x3a\x68\x49\x40\xea\x13\x12\xaa\x2e\x2c\x55\x69\x2b\x40\x2c\x57\x3c\x20\x54\x99\x64\x76\xd7\x25\xb1\x7d\x6d\x07\xca\x8d\xf2\xdf\x2b\xdb\xd9\xaf\x64\x81\x50\x96\xbd\x2f\xfb\x61\xcf\x9c\x99\x39\x67\x3c\x89\xab\x0a\x32\x1c\x33\x8e\x10\x8a\xfb\x7f\x30\x35\x21\xd4\xb5\xa4\xe9\x03\x9d\x20\x8c\xe9\xbd\x62\x69\x10\xb0\x42\x0a\x65\x80\x04\x00\x00\xa1\x36\x8a\xf1\x89\x0e\x03\xff\x77\xc2\xcc\xb4\xbc\x8f\x53\x51\x24\x13\xb1\x27\x24\x72\x2a\x59\xa2\x4a\x6e\x58\x81\xa1\xb3\x99\x1a\x23\x8d\xa2\x5c\x3b\x98\xd7\x3d\x92\x34\x67\xc8\x4d\xd8\x03\x3c\x29\x58\x96\xe5\xf8\x44\x15\x2e\xcc\x73\xea\xcd\xcd\x2f\x5a\x52\x65\x38\x2a\x9d\x68\xc9\x78\x96\x63\xa2\x51\x3d\xa2\x4a\x0a\x91\x61\xae\xdf\xe5\xa2\x50\x1b\x1b\x59\x48\x54\xd4\x30\xc1\x75\x52\x55\xa0\x39\x7d\x60\xdf\x11\xe2\x73\x5a\x20\xd4\xb5\x87\x4c\x75\xf1\x22\x6c\xaa\x8b\xbd\x89\xd8\xcb\xd9\x7d\x18\x44\x41\x60\x9e\x25\x42\x55\xcd\x01\x7e\xa7\x36\xa8\x02\x6d\x54\x99\x1a\xa8\x1c\x9e\xd7\x05\x76\x53\x5d\xc4\xc7\xa5\x66\x1c\xb5\xbe\x70\x6b\x23\x54\x8f\x2c\xc5\xa0\x0e\x82\x71\xc9\x53\x38\xc7\xa7\x2e\x18\x91\x8a\xf1\x94\xc9\x1c\x81\x71\x83\x6a\x4c\x53\xac\xea\x08\x76\xd7\xc4\xf5\x01\xb5\x87\x85\xc3\x23\x5b\x4b\x7c\x8e\x4f\x6b\xc3\x92\x28\xbe\x61\x66\x7a\x22\x38\x27\xf6\x03\x53\x4b\xcc\x22\x5c\x14\x2d\xa3\x39\xdb\x2f\xa5\x99\x12\x9b\x2a\x89\xa0\x11\x31\x3e\x71\x7a\xdb\x9d\x33\x3e\x16\x37\x8a\x19\x9b\x08\x28\x34\xa5\xe2\xab\xad\x13\x1f\x23\x55\xa8\xae\xc5\x03\x2e\xc5\x89\x89\xef\xc8\x28\x82\xda\xa7\xe4\xd3\xbc\x7e\x96\x48\xc2\xa5\x2a\xc3\xc8\xb7\x6c\x03\xbd\xd3\x25\xc0\xd7\xbf\x20\xfd\x70\x96\xfd\xc0\x6d\xd4\x73\xa6\xc9\x74\x1d\x7f\x11\xf8\x1f\x27\xa2\xe4\x66\x69\x9b\x48\x58\xd3\x2d\x71\xdb\xec\x92\x2a\x5a\xe8\x08\x16\x6d\x1d\x5f\xa1\x96\x82\x67\x73\x69\xd8\x00\x50\x29\xab\xcc\x34\xf6\x29\x7a\x14\xe2\xb9\x66\x63\xb7\xfd\xd3\x11\x70\x96\xc3\xa2\x9a\xa6\xe2\x76\x12\x75\x6d\xc5\x6d\xa7\x71\x4c\xb3\x2b\xfc\x56\xa2\x36\x8d\xc2\x97\xf4\x39\x17\x34\x23\x3b\xfe\xe0\xc4\xc7\x34\x53\xde\xa0\x3a\x55\x4a\xa8\x43\x1b\x34\x76\x3f\x49\x54\x47\x0d\x55\xaf\xc4\x85\xf5\x81\x2f\xfe\x7c\x21\xa0\x37\x74\x9f\x87\xc0\xea\xa8\xaf\x0c\x0a\xa9\xc1\x1e\x3a\xb4\xed\x7a\x08\x91\x24\x70\x32\xc5\xf4\x01\xce\x86\x90\x09\xd4\xfc\x67\x03\xf8\x2f\xd3\x46\xc7\x70\x85\x85\x78\x44\xbb\x63\xf5\x70\x8b\xbf\x3a\xa7\xb6\x74\x23\xfa\x88\x44\xc6\x43\x6a\xe8\x47\xf4\x6b\xa7\xbf\x3d\x01\xdb\x91\x3b\x0a\xce\x8a\xeb\x27\xd8\x10\x73\xec\x23\x58\xc7\xae\x87\x60\x6d\xee\x3d\x06\x91\xf1\xd9\xf0\x03\xdc\x77\x32\xd9\x1a\xf7\x9d\xc8\x96\xfb\x9e\x3c\x9f\xba\x9e\x7c\x9b\xe7\x8e\x5d\x0f\x9e\x15\xea\x32\x37\xda\x72\x7d\x7b\xb7\xdb\x14\xbd\x04\x51\xd5\x6b\xe5\xf8\x8d\xf1\x8c\xec\x34\xce\x1f\x10\xa4\x93\xf2\xd6\x04\xe9\x44\x7e\x71\x9c\x35\x96\xfe\xeb\x10\x72\xe4\x64\x56\xb8\xad\x76\xbf\xf7\x80\xb3\xa4\xbd\xad\x62\xcb\x6a\x73\x1a\x3e\x52\xe5\x14\x42\xcb\x55\x30\xd3\x4c\xc6\x37\x53\x54\xd8\xd5\x6d\xae\xb5\xdb\xff\x63\x74\x71\x4e\x76\x1b\xe3\x19\xcb\xee\x6b\x2c\x14\xfc\x3d\x00\x17\x5e\x51\x3e\x41\x90\xf1\x85\x5a\x64\xe7\x1e\xcf\x76\xb3\x79\x11\x8d\x47\x32\x67\x86\xe8\x01\x84\x10\x46\x73\x13\x36\x76\xcc\x8a\x08\x8e\x8e\x60\x7f\xc9\xd7\xbd\xa3\x09\x6e\x18\x2f\x71\xbe\x58\x03\xe6\x1a\x57\x9d\x0e\x5a\x4e\xf3\x02\x5c\x36\x44\xdc\xee\xdf\x0d\xdc\x1b\xd2\x17\x9d\x46\x6d\xa4\x9e\xae\x23\x57\xc3\xb5\x98\xad\x1f\xdc\x45\x4b\x50\xcb\xb4\x38\x6a\xff\x62\x05\x33\xaf\x50\xeb\xf6\x09\xe3\xc6\x52\xeb\xfe\x44\x51\x07\xe4\x92\x4e\x90\x97\xc5\x2b\x30\x23\x34\xd6\xe8\xbc\x2c\xee\x51\xcd\xe0\x1a\xb7\x17\x00\xb5\xed\xb9\x37\x11\x47\xec\x3b\x2e\xe3\x59\xaf\x55\x40\xdb\x50\x2f\xcf\x85\xff\x3f\x18\x5a\xa7\x60\x6b\x63\xa1\x15\xb7\x33\x14\xe6\xa5\xf5\x3f\xf2\xc7\xcf\x67\xc3\x7e\xc7\xbe\x65\xf9\x79\xe3\xdb\x9d\x62\x12\x5e\x61\x7a\x36\x0c\x7d\x67\x9f\x7e\x1b\x80\x7b\xba\x6e\x6c\xb6\xaf\xa9\x68\x83\x32\x36\x47\x7f\x3e\x89\x57\xa7\xc6\xdb\x22\xb7\x32\xeb\x08\xcd\x59\xfe\xbe\xae\x79\x0b\xb0\xc9\xf4\x76\xff\xee\x3d\xcd\x73\xc1\x7b\xbc\x60\x75\x0d\x3f\xaf\x75\xfc\xc8\x3a\xd8\x6c\x9b\xac\x26\xbf\xd5\xc3\xbe\x1a\x7a\x03\xaa\x7d\x95\x1a\x55\x8f\xeb\x64\xc7\xee\x9d\xd7\x98\xd9\xf5\xc5\x2f\xb0\x31\x28\x4c\x85\xca\xb6\x70\x83\xe9\x64\xbe\x35\xc1\x3a\x91\x3f\x78\x83\xf9\x2a\x33\x6a\xb0\xdf\x80\x5e\x6b\xdb\x43\x33\x9f\x51\xec\x66\x2d\x1c\xb9\x19\xfb\x89\xda\xfc\xa8\xe7\xe6\x5a\x76\x5e\x51\xa7\xaa\x00\x79\x06\x75\x1d\xfc\x17\x00\x00\xff\xff\xdc\x39\x9d\x54\xd3\x14\x00\x00")

func templatesObjectGotmplBytes() ([]byte, error) {
	return bindataRead(
		_templatesObjectGotmpl,
		"templates/object.gotmpl",
	)
}

func templatesObjectGotmpl() (*asset, error) {
	bytes, err := templatesObjectGotmplBytes()
	if err != nil {
		return nil, err
	}

	info := bindataFileInfo{name: "templates/object.gotmpl", size: 5331, mode: os.FileMode(420), modTime: time.Unix(1494534117, 0)}
	a := &asset{bytes: bytes, info: info}
	return a, nil
}

// Asset loads and returns the asset for the given name.
// It returns an error if the asset could not be found or
// could not be loaded.
func Asset(name string) ([]byte, error) {
	cannonicalName := strings.Replace(name, "\\", "/", -1)
	if f, ok := _bindata[cannonicalName]; ok {
		a, err := f()
		if err != nil {
			return nil, fmt.Errorf("Asset %s can't read by error: %v", name, err)
		}
		return a.bytes, nil
	}
	return nil, fmt.Errorf("Asset %s not found", name)
}

// MustAsset is like Asset but panics when Asset would return an error.
// It simplifies safe initialization of global variables.
func MustAsset(name string) []byte {
	a, err := Asset(name)
	if err != nil {
		panic("asset: Asset(" + name + "): " + err.Error())
	}

	return a
}

// AssetInfo loads and returns the asset info for the given name.
// It returns an error if the asset could not be found or
// could not be loaded.
func AssetInfo(name string) (os.FileInfo, error) {
	cannonicalName := strings.Replace(name, "\\", "/", -1)
	if f, ok := _bindata[cannonicalName]; ok {
		a, err := f()
		if err != nil {
			return nil, fmt.Errorf("AssetInfo %s can't read by error: %v", name, err)
		}
		return a.info, nil
	}
	return nil, fmt.Errorf("AssetInfo %s not found", name)
}

// AssetNames returns the names of the assets.
func AssetNames() []string {
	names := make([]string, 0, len(_bindata))
	for name := range _bindata {
		names = append(names, name)
	}
	return names
}

// _bindata is a table, holding each asset generator, mapped to its name.
var _bindata = map[string]func() (*asset, error){
	"templates/connection.gotmpl": templatesConnectionGotmpl,
	"templates/object.gotmpl": templatesObjectGotmpl,
}

// AssetDir returns the file names below a certain
// directory embedded in the file by go-bindata.
// For example if you run go-bindata on data/... and data contains the
// following hierarchy:
//     data/
//       foo.txt
//       img/
//         a.png
//         b.png
// then AssetDir("data") would return []string{"foo.txt", "img"}
// AssetDir("data/img") would return []string{"a.png", "b.png"}
// AssetDir("foo.txt") and AssetDir("notexist") would return an error
// AssetDir("") will return []string{"data"}.
func AssetDir(name string) ([]string, error) {
	node := _bintree
	if len(name) != 0 {
		cannonicalName := strings.Replace(name, "\\", "/", -1)
		pathList := strings.Split(cannonicalName, "/")
		for _, p := range pathList {
			node = node.Children[p]
			if node == nil {
				return nil, fmt.Errorf("Asset %s not found", name)
			}
		}
	}
	if node.Func != nil {
		return nil, fmt.Errorf("Asset %s not found", name)
	}
	rv := make([]string, 0, len(node.Children))
	for childName := range node.Children {
		rv = append(rv, childName)
	}
	return rv, nil
}

type bintree struct {
	Func     func() (*asset, error)
	Children map[string]*bintree
}
var _bintree = &bintree{nil, map[string]*bintree{
	"templates": &bintree{nil, map[string]*bintree{
		"connection.gotmpl": &bintree{templatesConnectionGotmpl, map[string]*bintree{}},
		"object.gotmpl": &bintree{templatesObjectGotmpl, map[string]*bintree{}},
	}},
}}

// RestoreAsset restores an asset under the given directory
func RestoreAsset(dir, name string) error {
	data, err := Asset(name)
	if err != nil {
		return err
	}
	info, err := AssetInfo(name)
	if err != nil {
		return err
	}
	err = os.MkdirAll(_filePath(dir, filepath.Dir(name)), os.FileMode(0755))
	if err != nil {
		return err
	}
	err = ioutil.WriteFile(_filePath(dir, name), data, info.Mode())
	if err != nil {
		return err
	}
	err = os.Chtimes(_filePath(dir, name), info.ModTime(), info.ModTime())
	if err != nil {
		return err
	}
	return nil
}

// RestoreAssets restores an asset under the given directory recursively
func RestoreAssets(dir, name string) error {
	children, err := AssetDir(name)
	// File
	if err != nil {
		return RestoreAsset(dir, name)
	}
	// Dir
	for _, child := range children {
		err = RestoreAssets(dir, filepath.Join(name, child))
		if err != nil {
			return err
		}
	}
	return nil
}

func _filePath(dir, name string) string {
	cannonicalName := strings.Replace(name, "\\", "/", -1)
	return filepath.Join(append([]string{dir}, strings.Split(cannonicalName, "/")...)...)
}

